local _G = getfenv(0)
local gsub = gsub

CharSheetPlus = {
	["Mode"] = 0,
	["ExtraStatFrameLeftDropDown"] = "PLAYERSTAT_BASE_STATS",
	["ExtraStatFrameRightDropDown"] = "PLAYERSTAT_BASE_STATS",
}

function CharSheet_OnEvent(self, event, addon)
	if event == "ADDON_LOADED" then
		if addon == "CharSheetPlus" then
			if CharSheetPlus.Mode == 1 then CharSheetToggle() end
		end
	elseif event == "PLAYER_LOGIN" then
		if IsAddOnLoaded("MrDressUp") then
			MrDressupFrameShowHelm:ClearAllPoints()
			MrDressupFrameShowHelm:SetPoint("BOTTOMLEFT", CharSheetButton, "TOPLEFT", -1, 0)
			MrDressupFrameShowHelmText:SetText("Helm")
			MrDressupFrameShowHelm:SetHitRectInsets(0,0,0,0)
			MrDressupFrameShowCloakText:SetText("Cloak")
			MrDressupFrameShowCloak:SetHitRectInsets(0,0,0,0)
		end
		if IsAddOnLoaded("GearScore") or IsAddOnLoaded("GearScoreLite") then
			PersonalGearScore:ClearAllPoints()
			PersonalGearScore:SetPoint("BOTTOMLEFT",GearScore2,"TOPLEFT",0,0)
			GearScore2:ClearAllPoints()
			GearScore2:SetPoint("BOTTOMLEFT",CharSheetButton,"BOTTOMRIGHT",1,1)
		end
	end
end

function CharSheet_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_LOGIN")
	PlayerTitlePickerFrame:SetFrameLevel(PlayerTitlePickerFrame:GetFrameLevel()+2)
	ExtraStatFrameLeftDropDown:SetWidth(124)
	ExtraStatFrameLeftDropDownMiddle:SetWidth(99)
	ExtraStatFrameLeftDropDownText:SetWidth(124)
	ExtraStatFrameRightDropDown:SetWidth(124)
	ExtraStatFrameRightDropDownMiddle:SetWidth(99)
	ExtraStatFrameRightDropDownText:SetWidth(124)
end

function CharSheetToggle()
	if CharSheetPlusFrame:IsShown() then
		CharSheetPlus.Mode = 0
		CharSheetPlusFrame:Hide()
		CharacterModelFrame:Show()
		CharSheetButton:ClearAllPoints()
		--CharSheetButton:SetPoint("BOTTOMLEFT", PlayerStatFrameLeftDropDown, "TOPLEFT", 15, -5)
		CharSheetButton:SetPoint("BOTTOMLEFT", PlayerStatFrameLeftDropDown, "TOPLEFT", 18, 0)
		CharSheetButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up")
		CharSheetButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down")
		MagicResFrame1:ClearAllPoints()
		MagicResFrame1:SetPoint("TOPLEFT", CharacterResistanceFrame, "TOPLEFT", 0, 0)
		MagicResFrame2:ClearAllPoints()
		MagicResFrame2:SetPoint("TOP", MagicResFrame1, "BOTTOM", 0, 0)
		MagicResFrame3:ClearAllPoints()
		MagicResFrame3:SetPoint("TOP", MagicResFrame2, "BOTTOM", 0, 0)
		MagicResFrame4:ClearAllPoints()
		MagicResFrame4:SetPoint("TOP", MagicResFrame3, "BOTTOM", 0, 0)
		MagicResFrame5:ClearAllPoints()
		MagicResFrame5:SetPoint("TOP", MagicResFrame4, "BOTTOM", 0, 0)
	else
		CharSheetPlus.Mode = 1
		CharSheetPlusFrame:Show()
		CharacterModelFrame:Hide()
		CharSheetButton:ClearAllPoints()
		CharSheetButton:SetPoint("BOTTOMLEFT", ExtraStatFrameLeftDropDown, "TOPLEFT", 18, 0)
		CharSheetButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
		CharSheetButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
		MagicResFrame5:ClearAllPoints()
		MagicResFrame5:SetPoint("TOPRIGHT", CharacterResistanceFrame, "TOPRIGHT", 0, 0)
		MagicResFrame4:ClearAllPoints()
		MagicResFrame4:SetPoint("RIGHT", MagicResFrame5, "LEFT", 0, 0)
		MagicResFrame3:ClearAllPoints()
		MagicResFrame3:SetPoint("RIGHT", MagicResFrame4, "LEFT", 0, 0)
		MagicResFrame2:ClearAllPoints()
		MagicResFrame2:SetPoint("RIGHT", MagicResFrame3, "LEFT", 0, 0)
		MagicResFrame1:ClearAllPoints()
		MagicResFrame1:SetPoint("RIGHT", MagicResFrame2, "LEFT", 0, 0)
	end
end

function CharSheetDrop_OnLoad(self)
	UIDropDownMenu_Initialize(self, CharSheetDrop_Initialize)
	UIDropDownMenu_SetSelectedValue(self, CharSheetPlus[self:GetName()])
	UIDropDownMenu_JustifyText(self, "LEFT")
end

function CharSheetDrop_OnShow(self)
	UIDropDownMenu_Initialize(self, CharSheetDrop_Initialize)
	UIDropDownMenu_SetSelectedValue(self, CharSheetPlus[self:GetName()])
end

function CharSheetDrop_Initialize(self)
	local info = UIDropDownMenu_CreateInfo()
	local checked
	for i=1, #PLAYERSTAT_DROPDOWN_OPTIONS do
		if ( PLAYERSTAT_DROPDOWN_OPTIONS[i] == CharSheetPlus[self:GetName()] ) then
			checked = 1
		else
			checked = nil
		end
		info.text = _G[PLAYERSTAT_DROPDOWN_OPTIONS[i]]
		info.func = CharSheetDrop_OnClick
		info.value = PLAYERSTAT_DROPDOWN_OPTIONS[i]
		info.checked = checked
		info.owner = UIDROPDOWNMENU_OPEN_MENU
		UIDropDownMenu_AddButton(info)
	end
end

function CharSheetDrop_OnClick(self)
	local var = self.owner:GetName()
	UIDropDownMenu_SetSelectedValue(self.owner, self.value)
	CharSheetPlus[var] = self.value
	UpdatePaperdollStats( gsub(var, "(ExtraStatFrame.+)DropDown", "%1"), self.value)
end

hooksecurefunc("PaperDollFrame_UpdateStats", function()
	UpdatePaperdollStats("ExtraStatFrameLeft", CharSheetPlus["ExtraStatFrameLeftDropDown"])
	UpdatePaperdollStats("ExtraStatFrameRight", CharSheetPlus["ExtraStatFrameRightDropDown"])
end)
